---
title: XRTargetRayMode
slug: Web/API/XRTargetRayMode
tags:
  - 3D
  - API
  - AR
  - Enum
  - Enumerated Type
  - Input
  - Reality
  - Reference
  - Type
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRTargetRayMode
  - augmented
  - source
  - target
---
<p>{{APIRef("WebXR")}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> enumerated type <strong><code>XRTargetRayMode</code></strong> describes the method by an input controller's targeting ray is being produced.</span> Targeting may be done by looking at the target using a gaze-tracking system, pointing at the target with a hand controller, glove, or motion-tracking system, or by tapping or clicking on the target using a finger on a screen or with a mouse.</p>

<p>Typically a <strong>target ray</strong> is drawn from the source of the targeting system along the target ray in the direction in which the user is looking or pointing. The style of the ray is generally up to you, as is the method for indicating the endpoint of the ray. The targeted point or object might be indicated by drawing a shape or highlighting the targeted surface or object.</p>

<div style="width: 42em;">
<figure style="background: #eee; padding: 0.5em; border: 1px solid #aaa; border-radius: 1em; max-width: 504px; padding: 1em; margin: 1em auto;">
<figcaption><strong>A target ray emitted by a hand controller.</strong></figcaption>
<img alt="A screenshot showing a target ray being emitted by a hand controller" src="https://mdn.mozillademos.org/files/17089/example-target-ray.gif" style="width: 100%;"></figure>
</div>

<p>The target ray can be anything from a simple line (ideally fading over distance) to an animated effect, such as the science-fiction "phaser" style shown in the screenshot above.</p>

<h2 id="Values">Values</h2>

<dl>
 <dt><code>gaze</code></dt>
 <dd>The user is using a gaze-tracking system (or <strong>gaze input</strong>) which detects the direction in which the user is looking. The target ray will be drawn originating at the viewer's eyes and will follow the direction in which they're looking.</dd>
 <dt><code>screen</code></dt>
 <dd>The direction of the target ray is indicated using a tap on a touch screen, mouse, or other tactile input device.</dd>
 <dt><code>tracked-pointer</code></dt>
 <dd>Targeting is being performed using a handheld device or hand-tracking system which the user points in the direction of the target. The target ray extends from the hand (or the object in the hand) in the targeted direction. The direction is determined using platform-specific rules, though if no such rules exist, the direction is chosen by assuming the user is pointing their index finger straight out from their hand.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This fragment of code shows part of a function to be called once every frame. It looks for inputs which have a non-<code>null</code> {{domxref("XRInputSource.targetRaySpace", "targetRaySpace")}}. Inputs which have a value for this property represent inputs that project a target ray outward from the user.</p>

<p>For each such input, this example looks for inputs whose {{domxref("XRInputSource.targetRayMode", "targetRayMode")}} is <code>tracked-pointer</code>, indicating that the input is in fact intended to represent a targeting device rather than a gazing device, screen tap, or mouse click. For tracked pointers, a function <code>myRenderTargetRayAsBeam()</code> is called to render a beam from the input controller's virtual position outward in the direction it's pointing.</p>

<p>The code should continue to perform tasks such as drawing controllers or any objects representative of the user's hands' positions in the virtual space, as well as any other input-related tasks.</p>

<pre class="brush: js notranslate">function updateInputSources(session, frame, refSpace) {
  for (let source of session.getInputSources()) {
    let targetRayPose = frame.getPose(inputSource.targetRaySpace, refSpace);

    if (targetRayPose) {
      if (source.targetRayMode == "tracked-pointer") {
        myRenderTargetRayAsBeam(targetRayPose);
      }
    }

    /* ... */
  }
}
</pre>

<p>See the article <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a> for more details and a more complete example.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#enumdef-xrtargetraymode','XRTargetRayMode')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRTargetRayMode")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
</ul>
